# ChatRoller Plugin

This unofficial TaleSpire plugin is for adding chat rolls with optional character sheet lookups.

OBSOLETE: Please use Chat Roll Plugin instead (https://talespire.thunderstore.io/package/LordAshes/ChatRollPlugin/)

![Preview](https://i.imgur.com/sB4X2vc.png)

## Install

User R2ModMan or similar to download and install the plugin. The plugin includes a TaleSpire_CustomData ZIP
file. Expand the ZIP into your TaleSpire game folder. If the TaleSpire_CustomData folder already exists in
your TaleSpire game folder, merge the contents with the existing contents. This will make the radial menu
die icon available for this plugin.

## Usage

Open the roll dialog using the keyboard shortcut (LCTRL+R by default but can be changed in R2ModMan config for
the plugin) when a mini is selected or select the die icon from a mini's radial menu. Enter a die roll expression
using the regular D noration (e.g. 3D6). The expression can use basic math operations like plus, minus,
multiplication and division. If the selected mini has a defined character sheet in the TaleSpire_CustomData/Misc
folder then the character sheet replacement will be applied when evaluating the roll. For example, one can define
a Stealth roll which would equate to 1D20+PB+StealthBonus where PB and StealthBonus are also defined in the
character sheet.

The character sheet is a file with a .CHS extension and contains one key/value pairs line separated by the
equal sign. Each key (the left side of the equal sign) will be replace with the corresponding value (the right
side of the equal sign) before evaluating the roll. Text can be added using single quotes and replacement will
not be done with text. When adding text numeric values after text, surround the values in brackets. For example:
Stealth='Stealth:'+(1D20+PB+StealthBonus)  

The Char Roller Plugin supports different "edition" or "style" character sheets. The edition is a prefix to the
character sheet file name. By default the edition is set to "Dnd5e" but the default can be changed in the R2ModMan
configuration for the plugin or the edition can be changed in-game by using the correspodning keyboard shortcut
(LCTRL+E by default). For example, to make a character sheet for "Jon" using "Dnd35e" edition, one would create
the file:

``.\TaleSpire\TaleSpire_CustomData\Misc\Dnd35e.Jon.chs``

The "edition" is not important if the Chat Roller is not being used for character sheets. For example, if all of
the rolls are written out like "1D20+3" instead of using character sheet keywords then the edition does not matter.

## Change Log

```
1.4.4: Marked icon as obsolete. Removed plugin content.
1.4.3: Marked as obsolete. Replaced by the Chat Roll plugin.
1.4.3: Relinked with latest BR build.
1.4.2: Added preview image (no change to plugin)
1.4.1: Makes the RollHandler public so that other plugins can use the Chat Roller plugin as a dependency
1.4.0: Uses dialog for roll entry instead of text (LCTRL+R by default)
1.4.0: Adds icon to mini's radial menu unless disabled in the configuration
1.4.0: Simpler formatting to make the message display for a shorter time
1.3.0: Fixed compatability with Stat Messaging plugin (and any pluging that uses it)
1.2.3: Improved formatting on the roll result output 
1.2.2: Exposed GetEdition() and SetEdition() for plugins that use this plugin as a dependency
1.2.1: Moved characters sheets to TaleSpire_CustomData/Misc
1.2.1: Added support for Edition (for use by plugins that depend on this plugin)
```